package cs3500.connectn.consoleui;

import cs3500.connectn.model.Player;
import org.junit.Test;

import java.io.IOException;

import static cs3500.connectn.model.Player.Red;
import static cs3500.connectn.model.Player.White;
import static org.junit.Assert.assertEquals;

/**
 * Tests for {@code ConsoleView}, but not enough.
 */
public class ConsoleViewTest {
  Appendable out = new StringBuilder();
  View view = ConsoleView.builder().output(out).build();

  ViewModel vm = new ViewModel(2, 3) {
    @Override public Player getPlayerAt(int x, int y) {
      return grid[grid.length - y - 1][x];
    }

    Player[][] grid =
      {{null,  null},
       {Red,   White},
       {White, Red}};
  };

  @Test
  public void drawsAsExpected() throws IOException {
    view.draw(vm);

    assertEquals("| | |\n" +
                 "|R|W|\n" +
                 "|W|R|\n" +
                 "+-+-+\n" +
                 " 0 1\n",
                 out.toString());
  }

  ViewModel wideVm = new ViewModel(32, 3) {
    @Override public Player getPlayerAt(int x, int y) { return null; }
  };

  @Test(expected = IllegalArgumentException.class)
  public void throwsIfModelTooWide() throws IOException {
    ConsoleView.builder().build().draw(wideVm);
  }
}
